#| 
Autor :   Adrian Fichte
Email adrian@36zero.de
                                   
|#

(in-package :AdrianF)
(use-package :OLI)


;;---------------------------------------------------------------------------------------------------------------------


(sd-defdialog 'AF_Hohlprofil
	:toolbox-button nil
	:dialog-title (sd-multi-lang-string "Piping" :german "Hohlprofil erstellen")
	:persistent-proposals T 
:help-action 
  '(progn 
	(display :show  )
	(display  "Diese Tool wurde von Adrian Fichte entwickelt!")
	(display  " ")
	(display  "www.36zero.de .:. adrian@36zero.de")
)
	:variables
   '(
     ;; local variables:
     (BACK-STATES :initial-value nil)
     (CURR-WP :initial-value (sd-inq-curr-wp))
     (PIPE-WP :initial-value
	      (let ((name (sd-gen-obj-basename :workplane
					       :prefix "AE-Rohr")))
		(sd-call-cmds (create_workplane :new :name name))
		(sd-pathname-to-obj (sd-pathlist-to-pathname
				     (list "/" name)))))
     (PIPE-PROFILE :initial-value nil)
     (DIR-FBACK :initial-value nil)
     (PREVIEW-FBACK :initial-value nil)
     (NEXT-PERFORMED :initial-value nil)
     (STRAIGHT 	:initial-value t)  ;; straight or bend section?
     (STRAIGHT-LEN :initial-value nil)
     (BEND-AXIS :initial-value nil)
     ;; dialog vaiables:
     (PIPE_PART :value-type :part-incl-new
				:initial-value "/"
				:title (sd-multi-lang-string "Part" :german "Teil")
				:modifies :contents
				:after-input (handle-ok-next-action))
     (subtitle-ruler-wp :title (sd-multi-lang-string "Workplane" :german "Arbeitsebene"))
     (ORIGIN 	:value-type :point-3d
				:title (sd-multi-lang-string "Origin" :german "Ursprung")
				:initial-value (sd-inq-wp-origin pipe-wp)
				:after-input (progn
			    (handle-ok-next-action)
			    (sd-call-cmds (position_wp pipe-wp
						       :pt_dir
						       :origin origin
						       :normal :w :done))
			    (start-dir-fback)))
     (DIRECTION :value-type :measure-direction
		:built-in-feedback nil
		:title (sd-multi-lang-string "Direction" :german "Richtung")
		:initial-value
		(let ((dir (sd-inq-wp-w-dir pipe-wp)))
		  (setq dir-fback (sd-start-direction-feedback :point origin
							       :direction dir
							       :disc nil))
		  (list dir))
		:check-function
		#'(lambda (new-dir)
		    (if (first bend_dir)
			(if (vec-collinear-p (first new-dir) (first bend_dir))
			    (values :error "Direction collinear to specified Bend direction not allowed.")
			  :ok)
		      :ok))
		:after-input (progn
			       (handle-ok-next-action)
			       (sd-call-cmds (position_wp pipe-wp
							  :pt_dir
							  :origin origin
							  :normal (first direction)
							  :done))
			       (start-dir-fback)))
    (u_achse_aendern
      :expand-shrink (UDIR)
      :expand-shrink-toggle-type :boolean
      :toggle-type :wide-toggle
      :title (sd-multi-lang-string "U Axis Direction" :german "U-Achsrichtung ndern")
      :initial-value nil
      :next-variable 'udir
    )
    (udir
      :value-type :measure-direction
      :built-in-feedback nil
      :initial-value nil
      :title (sd-multi-lang-string "U Direction" :german "U-Richtung")
      :before-input
      (setf udir nil)
      :after-input
      (progn
        (handle-ok-next-action)
        (sd-call-cmds
			(position_wp
				pipe-wp
					:pt_dir
					:origin origin
					:normal (first direction)
					:u_dir (first udir)
					:done
			)
 		)
 			(setf u_achse_aendern nil)
 	    )
 	  )
	  	(Hilfslinie 	:expand-shrink (v_koord U_koord )
					:expand-shrink-toggle-type :boolean)
	(v_koord 		:value-type :length
					:title "V-Koordinate"
				    :after-input (progn
								(when (and v_koord u_koord)
									(sd-call-cmds (C_LINE_INF :HORIZONTAL v_koord));; horizontale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :VERTICAL u_koord));; vertikale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :HORIZONTAL 0));; horizontale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :VERTICAL 0));; vertikale Hilfegeometrie im Schwerpunkt erstellen
								)))
	(u_koord 		:value-type :length
					:title "U-Koordinate"
				    :after-input (progn
								(when (and v_koord u_koord)
									(sd-call-cmds (C_LINE_INF :HORIZONTAL v_koord));; horizontale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :VERTICAL u_koord));; vertikale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :HORIZONTAL 0));; horizontale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :VERTICAL 0));; vertikale Hilfegeometrie im Schwerpunkt erstellen
								)))


    (header-profil :title (sd-multi-lang-string "Profil" :german "Profil"))
    (PUSH-QP    :push-action (sd-show-display-table "DIN-EN-10219-2-QRO" :position '("TOP-MENU-TOOLBOX-TB" :lefttop 900 50))
				:title "Quadratische Hohlprofile" :toggle-type :wide-toggle)
    (PUSH-RP    :push-action (sd-show-display-table "DIN-EN-10219-2-RRO" :position '("TOP-MENU-TOOLBOX-TB" :lefttop 900 50))
				:title "Rechteckige Hohlprofile" :toggle-type :wide-toggle)
    (header-querschnitt :title (sd-multi-lang-string "Cross Section" :german "Querschnitt"))
    (laenge_1 	:value-type :positive-length
				:title (sd-multi-lang-string "Height" :german "Hhe")
				:after-input (progn
			    (handle-ok-next-action)
			    (when pipe-profile
					(sd-call-cmds
						(delete_2d :all_2d)
					)
				)
			(GEOMETRY_MODE :REAL)					;ndert die Geometrieart auf "Geometrie" falls das nicht eingestellt ist
	        (when (and laenge_1 laenge_2 wandst Radius1)
	          (if (> laenge_1 laenge_2) 
					(setf radius (/ laenge_1 2)))
	          (if (> laenge_1 laenge_2) 
					(setf radius (/ laenge_2 2)))
	          (setf pa1 (make-gpnt2d :x (- (/ laenge_1 2)) :y (- (/ laenge_2 2)) )) ;; links unten
	          (setf pa2 (make-gpnt2d :x (- (/ laenge_1 2)) :y    (/ laenge_2 2))  ) ;; links oben
	          (setf pa3 (make-gpnt2d :x    (/ laenge_1 2)  :y    (/ laenge_2 2))  ) ;; rechts oben
	          (setf pa4 (make-gpnt2d :x    (/ laenge_1 2)  :y (- (/ laenge_2 2)) )) ;; rechts unten

	          (setf pi1 (make-gpnt2d :x (- (- (/ laenge_1 2) wandst)) :y (- (- (/ laenge_2 2) wandst)) )) ;; links unten
	          (setf pi2 (make-gpnt2d :x (- (- (/ laenge_1 2) wandst)) :y    (- (/ laenge_2 2) wandst))  ) ;; links oben
	          (setf pi3 (make-gpnt2d :x    (- (/ laenge_1 2) wandst)  :y    (- (/ laenge_2 2) wandst))  ) ;; rechts oben
	          (setf pi4 (make-gpnt2d :x    (- (/ laenge_1 2) wandst)  :y (- (- (/ laenge_2 2) wandst)) )) ;; rechts unten

	          (sd-call-cmds
		          (rectangle pa1 pa3)
  	        )
	          (sd-call-cmds
		          (rectangle pi1 pi3)
  	        )
	          (when (> Radius1 0)
	            (sd-call-cmds
		            (fillet :create :fillet_radius Radius1 pa1 pa2 pa3 pa4)
  	          )
  	        )
	          (when (> Radius1 wandst)
	            (sd-call-cmds
		            (fillet :create :fillet_radius (- Radius1 wandst) pi1 pi2 pi3 pi4)
  	          )
  	        )
  	      )
		      (sd-call-cmds
		        (c_point 0,0)
	        )
			    (setq pipe-profile t)))
				
				
				
				
     (laenge_2 	:value-type :positive-length
				:title (sd-multi-lang-string "Width" :german "Breite")
				:after-input (progn
			    (handle-ok-next-action)
			    (when pipe-profile
					(sd-call-cmds
						(delete_2d :all_2d)
					)
				)
			(GEOMETRY_MODE :REAL)					;ndert die Geometrieart auf "Geometrie" falls das nicht eingestellt ist
	        (when (and laenge_1 laenge_2 wandst Radius1)
	          (if (> laenge_1 laenge_2) 
					(setf radius (/ laenge_1 2)))
	          (if (> laenge_1 laenge_2) 
					(setf radius (/ laenge_2 2)))
	          (setf pa1 (make-gpnt2d :x (- (/ laenge_1 2)) :y (- (/ laenge_2 2)) )) ;; links unten
	          (setf pa2 (make-gpnt2d :x (- (/ laenge_1 2)) :y    (/ laenge_2 2))  ) ;; links oben
	          (setf pa3 (make-gpnt2d :x    (/ laenge_1 2)  :y    (/ laenge_2 2))  ) ;; rechts oben
	          (setf pa4 (make-gpnt2d :x    (/ laenge_1 2)  :y (- (/ laenge_2 2)) )) ;; rechts unten

	          (setf pi1 (make-gpnt2d :x (- (- (/ laenge_1 2) wandst)) :y (- (- (/ laenge_2 2) wandst)) )) ;; links unten
	          (setf pi2 (make-gpnt2d :x (- (- (/ laenge_1 2) wandst)) :y    (- (/ laenge_2 2) wandst))  ) ;; links oben
	          (setf pi3 (make-gpnt2d :x    (- (/ laenge_1 2) wandst)  :y    (- (/ laenge_2 2) wandst))  ) ;; rechts oben
	          (setf pi4 (make-gpnt2d :x    (- (/ laenge_1 2) wandst)  :y (- (- (/ laenge_2 2) wandst)) )) ;; rechts unten

	          (sd-call-cmds
		          (rectangle pa1 pa3)
  	        )
	          (sd-call-cmds
		          (rectangle pi1 pi3)
  	        )
	          (when (> Radius1 0)
	            (sd-call-cmds
		            (fillet :create :fillet_radius Radius1 pa1 pa2 pa3 pa4)
  	          )
  	        )
	          (when (> Radius1 wandst)
	            (sd-call-cmds
		            (fillet :create :fillet_radius (- Radius1 wandst) pi1 pi2 pi3 pi4)
  	          )
  	        )
  	      )
		      (sd-call-cmds
		        (c_point 0,0)
	        )
			    (setq pipe-profile t)))
				
				
				
				
     (wandst :value-type :positive-length
	     :title (sd-multi-lang-string "Wall Thickness" :german "Wandstrke")
         ;:proposals '(1 2 2.3 2.6 3 3.2 3.6 4 5 6.3 8 10) :auto-add-proposal T  ;; keep entered values
				:after-input (progn
			    (handle-ok-next-action)
			    (when pipe-profile
					(sd-call-cmds
						(delete_2d :all_2d)
					)
				)
			(GEOMETRY_MODE :REAL)					;ndert die Geometrieart auf "Geometrie" falls das nicht eingestellt ist
	        (when (and laenge_1 laenge_2 wandst Radius)
	          
	          (setf pa1 (make-gpnt2d :x (- (/ laenge_1 2)) :y (- (/ laenge_2 2)) )) ;; links unten
	          (setf pa2 (make-gpnt2d :x (- (/ laenge_1 2)) :y    (/ laenge_2 2))  ) ;; links oben
	          (setf pa3 (make-gpnt2d :x    (/ laenge_1 2)  :y    (/ laenge_2 2))  ) ;; rechts oben
	          (setf pa4 (make-gpnt2d :x    (/ laenge_1 2)  :y (- (/ laenge_2 2)) )) ;; rechts unten

	          (setf pi1 (make-gpnt2d :x (- (- (/ laenge_1 2) wandst)) :y (- (- (/ laenge_2 2) wandst)) )) ;; links unten
	          (setf pi2 (make-gpnt2d :x (- (- (/ laenge_1 2) wandst)) :y    (- (/ laenge_2 2) wandst))  ) ;; links oben
	          (setf pi3 (make-gpnt2d :x    (- (/ laenge_1 2) wandst)  :y    (- (/ laenge_2 2) wandst))  ) ;; rechts oben
	          (setf pi4 (make-gpnt2d :x    (- (/ laenge_1 2) wandst)  :y (- (- (/ laenge_2 2) wandst)) )) ;; rechts unten

	          (sd-call-cmds
		          (rectangle pa1 pa3)
  	        )
	          (sd-call-cmds
		          (rectangle pi1 pi3)
  	        )
	          (when (> Radius 0)
	            (sd-call-cmds
		            (fillet :create :fillet_radius Radius pa1 pa2 pa3 pa4)
  	          )
  	        )
	          (when (> Radius wandst)
	            (sd-call-cmds
		            (fillet :create :fillet_radius (- Radius wandst) pi1 pi2 pi3 pi4)
  	          )
  	        )
  	      )
		      (sd-call-cmds
		        (c_point 0,0)
	        )
			    (setq pipe-profile t)))
				
				
				
				
     (Radius :value-type :length ;;:positive-length
	     :title (sd-multi-lang-string "Corner Radius" :german "Radius")
        ; :proposals '() :auto-add-proposal T  ;; keep entered values
				:after-input (progn
			    (handle-ok-next-action)
			    (when pipe-profile
					(sd-call-cmds
						(delete_2d :all_2d)
					)
				)
			(GEOMETRY_MODE :REAL)					;ndert die Geometrieart auf "Geometrie" falls das nicht eingestellt ist
	        (when (and laenge_1 laenge_2 wandst Radius)
	          
	          (setf pa1 (make-gpnt2d :x (- (/ laenge_1 2)) :y (- (/ laenge_2 2)) )) ;; links unten
	          (setf pa2 (make-gpnt2d :x (- (/ laenge_1 2)) :y    (/ laenge_2 2))  ) ;; links oben
	          (setf pa3 (make-gpnt2d :x    (/ laenge_1 2)  :y    (/ laenge_2 2))  ) ;; rechts oben
	          (setf pa4 (make-gpnt2d :x    (/ laenge_1 2)  :y (- (/ laenge_2 2)) )) ;; rechts unten

	          (setf pi1 (make-gpnt2d :x (- (- (/ laenge_1 2) wandst)) :y (- (- (/ laenge_2 2) wandst)) )) ;; links unten
	          (setf pi2 (make-gpnt2d :x (- (- (/ laenge_1 2) wandst)) :y    (- (/ laenge_2 2) wandst))  ) ;; links oben
	          (setf pi3 (make-gpnt2d :x    (- (/ laenge_1 2) wandst)  :y    (- (/ laenge_2 2) wandst))  ) ;; rechts oben
	          (setf pi4 (make-gpnt2d :x    (- (/ laenge_1 2) wandst)  :y (- (- (/ laenge_2 2) wandst)) )) ;; rechts unten

	          (sd-call-cmds
		          (rectangle pa1 pa3)
  	        )
	          (sd-call-cmds
		          (rectangle pi1 pi3)
  	        )
	          (when (> Radius 0)
	            (sd-call-cmds
		            (fillet :create :fillet_radius Radius pa1 pa2 pa3 pa4)
  	          )
  	        )
	          (when (> Radius wandst)
	            (sd-call-cmds
		            (fillet :create :fillet_radius (- Radius wandst) pi1 pi2 pi3 pi4)
  	          )
  	        )
  	      )
		      (sd-call-cmds
		        (c_point 0,0)
	        )
			    (setq pipe-profile t)))
				
				
				
				
                
  	 (subtitle-ruler-straight :title (sd-multi-lang-string "Straight" :german "Gerade")) 
     (STRAIGHT_LENGTH :value-type :positive-length
		      :title (sd-multi-lang-string "Length" :german "Lnge")
              :proposals '() :auto-add-proposal T  ;; keep entered values
		      :after-input (switch-to-straight))
     (STRAIGHT_TO_PNT :value-type :point-3d
		      :title (sd-multi-lang-string "To Point" :german "Zu Punkt")
		      :after-input (switch-to-straight))

     (subtitle-ruler-bend :title (sd-multi-lang-string "Bend" :german "Biegung"))
     (BEND_RADIUS :value-type :positive-length
		  :title "Radius"
          :proposals '() :auto-add-proposal T  ;; keep entered values
		  :toggle-type :toggle-data
		  :show-input-tool (show-standard-bend-table
				            :radius
				            :pipe-radius radius
				            :bend-radius bend_radius
				            :bend-angle bend_angle)
		  :hide-input-tool (hide-standard-bend-table)
		  :check-function #'(lambda (new-radius)
				      (if (or (not radius)
					      (>= new-radius radius))
					  :ok
					(values :error "Bend radius less than pipe radius not allowed.")))
		  :after-input (switch-to-bend))
     (BEND_ANGLE :value-type :angle
		 :title (sd-multi-lang-string "Angle" :german "Winkel")
         :proposals '() :auto-add-proposal T  ;; keep entered values
		 :initial-optional t
		 :show-input-tool (show-standard-bend-table
				           :angle
				           :pipe-radius radius
				           :bend-radius bend_radius
				           :bend-angle bend_angle)
  	     :hide-input-tool (hide-standard-bend-table)
		 :after-input (switch-to-bend))
     (BEND_DIR :value-type :measure-direction
	       :built-in-feedback nil
	       :title (sd-multi-lang-string "Direction" :german "Richtung")
	       :initial-optional t
	       :check-function
	       #'(lambda (new-dir)
		   (if (first direction)
		       (if (vec-collinear-p (first new-dir) (first direction))
			   (values :error "Bend direction collinear to Direction not allowed.")
			 :ok)
		     :ok))
	       :after-input (switch-to-bend))
		   

	
		  
	("Rorh - Segment")
    (NEXT :toggle-type :grouped-toggle
	   :title "Weiter"
	   :push-action (next-action))
    (BACK :toggle-type :grouped-toggle
	   :title (sd-multi-lang-string "Back" :german "Zurck")
	   :initial-enable nil
	   :push-action (back-action))
     )
   :mutual-exclusion '(straight_length straight_to_pnt bend_radius)
   :local-functions
   ;;--------------
   '((cleanup ()
       (sd-end-feedback preview-fback)
       (sd-end-feedback dir-fback)
       (sd-call-cmds (delete_3d pipe-wp))
       (sd-call-cmds (current_wp curr-wp)))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (handle-ok-next-action ()
       (setq next-performed nil)
       (sd-enable-must-variable-check))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (vec-collinear-p (vec1 vec2)
       (let ((angle (sd-vec-angle-between vec1 vec2)))
	 (if (or (< (abs angle) (sd-inq-default-geo-resolution))
		 (< (abs (- angle PI)) (sd-inq-default-geo-resolution)))
	     t
	   nil)))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (start-dir-fback ()
       (when (and origin (first direction))
	 (sd-end-feedback dir-fback)
	 (setq dir-fback (sd-start-direction-feedback
			  :point origin
			  :direction (first direction)
			  :disc nil))))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (end-dir-fback ()
       (sd-end-feedback dir-fback))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (start-preview-fback ()
       (end-preview-fback)
       (if straight
	   (progn
	     (if straight_length
		 (setq straight-len straight_length)
	       (setq straight-len
		     (sd-call-cmds (measure_dist :between_points
						 origin
						 straight_to_pnt
						 :direction (first direction)))))
	     (setq preview-fback (sd-start-direction-feedback
				  :point (sd-vec-translate origin
							   (first direction)
							   straight-len)
				  :direction (first direction))))
	 ;; ELSE: bend preview
	 (if (and bend_radius bend_angle bend_dir)
	     (let* ((cross1 (sd-vec-cross-product (first direction)
						  (first bend_dir)))
		    (cross2 (sd-vec-cross-product cross1 (first direction)))
		    (point (sd-vec-translate origin cross2 bend_radius)))
	       (setq preview-fback (sd-start-direction-feedback
				    :point (sd-vec-rotate origin
							  bend_angle
							  :point point
							  :direction cross1)
				    :direction (sd-dir-rotate
						(first direction)
						bend_angle
						:point point
						:direction cross1)))
	       (setq bend-axis (list point cross1)))
	   (setq bend-axis nil))))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (end-preview-fback ()
       (sd-end-feedback preview-fback))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (switch-to-straight ()
       (handle-ok-next-action)
       (setq straight t)
       (sd-set-variable-status 'bend_angle :optional t)
       (sd-set-variable-status 'bend_dir :optional t)
       (setq bend_angle nil)
       (setq bend_dir nil)
       (start-preview-fback))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (switch-to-bend ()
       (handle-ok-next-action)
       (setq straight nil)
       (sd-set-variable-status 'bend_radius :optional nil)
       (sd-set-variable-status 'bend_angle :optional nil)
       (sd-set-variable-status 'bend_dir :optional nil)
       (start-preview-fback))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    (next-action ()
       (setq next-performed t)
       (sd-disable-must-variable-check)
    (when (and pipe_part origin direction radius)
	(if straight
	     (when straight-len   ;; calculated in start-preview-fback
	       (end-dir-fback)
	       (end-preview-fback)
	       ;; remember current model state:
	       (push (list (sd-set-model-checkpoint) origin direction)
		     back-states)
	       ;; perform extrude and position_wp:
	    (sd-call-cmds (extrude 
					:part pipe_part	
					:wp pipe-wp
				    :distance straight-len 
					:keep_wp :yes))
	    (sd-call-cmds 	(position_wp pipe-wp :translate :dir_len
							(first direction) straight-len))
		(sd-call-cmds
			(recognize_blends 	:label_fdbk :on :sel_faces
								:sel_part Pipe_PART
			)
		)
		(sd-call-cmds
			(display :clear-hide)
		)
	(progn
        (sd-call-cmds (set_part_base_density :parts PIPE_PART :dens 0.00785))
		(sd-call-cmds (set_part_base_color :parts PIPE_PART :color :rgb 0.64,0.7,0.96))
    )
	    (setq origin (sd-inq-wp-origin pipe-wp))
	    (start-dir-fback))
	   ;; ELSE: perform bend operation:
	(when bend-axis    ;; calculated in start-preview-fback
	     (end-dir-fback)
	     (end-preview-fback)
	     ;; remember current model state:
	     (push (list (sd-set-model-checkpoint) origin direction)
		   back-states)
	     ;; perform turn and position_wp:
	    (sd-call-cmds (turn 	
					:part pipe_part 
					:wp pipe-wp
					:axis (first bend-axis) (second bend-axis)
					:rotation_angle bend_angle
					:keep_wp :yes))
	    (sd-call-cmds (position_wp pipe-wp 
					:rotate
					:axis (first bend-axis) (second bend-axis)
					:rotation_angle bend_angle
					:done))
		(sd-call-cmds
			(recognize_blends 	:label_fdbk :on :sel_faces
								:sel_part Pipe_PART
			)
		)
		(sd-call-cmds
			(display :clear-hide)
		)
       (progn
	        (sd-call-cmds (set_part_base_density :parts PIPE_PART :dens 0.00785))
	        (sd-call-cmds (set_part_base_color :parts PIPE_PART :color :rgb 0.64,0.7,0.96))
       )
	     (setq bend_dir nil)
	     (setq origin (sd-inq-wp-origin pipe-wp))
	     (setq direction (list (sd-inq-wp-w-dir pipe-wp)))
	     (start-dir-fback))))
       (when back-states
	 (sd-set-variable-status 'back :enable t)))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (back-action ()
       (when back-states
	 (let ((state (pop back-states)))
	   (end-dir-fback)
	   (sd-return-to-model-checkpoint (first state))
	   (setq origin (second state))
	   (setq direction (third state))
	   (start-dir-fback))
	 (unless back-states
	   (sd-set-variable-status 'back :enable nil))))
     )  ;; end of local functions
   :ok-action '(progn
		 (unless next-performed
		   (next-action))
		 (cleanup))
   :cancel-action '(cleanup)
   )