#| 
Autor :   Adrian Fichte
Email adrian@36zero.de
                                   
|#

(in-package :AdrianF)
(use-package :OLI)


;;---------------------------------------------------------------------------------------------------------------------


(sd-defdialog 'AF_Vieleck
	:toolbox-button nil
	:dialog-title "Vieleck"
	:persistent-proposals T 
:help-action 
  '(progn 
	(display :show  )
	(display  "Diese Tool wurde von Adrian Fichte entwickelt!")
	(display  " ")
	(display  "www.36zero.de .:. adrian@36zero.de")
)
	:variables
   '(
     ;; local variables:
     (BACK-STATES :initial-value nil)
     (CURR-WP :initial-value (sd-inq-curr-wp))
     (PIPE-WP :initial-value
	      (let ((name (sd-gen-obj-basename :workplane
					       :prefix "AE-Rohr")))
		(sd-call-cmds (create_workplane :new :name name))
		(sd-pathname-to-obj (sd-pathlist-to-pathname
				     (list "/" name)))))
     (PIPE-PROFILE :initial-value nil)
     (DIR-FBACK :initial-value nil)
     (PREVIEW-FBACK :initial-value nil)
     (NEXT-PERFORMED :initial-value nil)
     (STRAIGHT 	:initial-value t)  ;; straight or bend section?
     (STRAIGHT-LEN :initial-value nil)
     (BEND-AXIS :initial-value nil)
     ;; dialog vaiables:
     (PIPE_PART :value-type :part-incl-new
				:initial-value "/"
				:title (sd-multi-lang-string "Part" :german "Teil")
				:modifies :contents
				:after-input (handle-ok-next-action))
     (subtitle-ruler-wp :title (sd-multi-lang-string "Workplane" :german "Arbeitsebene"))
     (ORIGIN 	:value-type :point-3d
				:title (sd-multi-lang-string "Origin" :german "Ursprung")
				:initial-value (sd-inq-wp-origin PIPE-wp)
				:after-input (progn
			    (handle-ok-next-action)
			    (sd-call-cmds (position_wp PIPE-wp
						       :pt_dir
						       :origin origin
						       :normal :w :done))
			    (start-dir-fback)))
     (DIRECTION :value-type :measure-direction
		:built-in-feedback nil
		:title (sd-multi-lang-string "Direction" :german "Richtung")
		:initial-value
		(let ((dir (sd-inq-wp-w-dir PIPE-wp)))
		  (setq dir-fback (sd-start-direction-feedback :point origin
							       :direction dir
							       :disc nil))
		  (list dir))
		:check-function
		#'(lambda (new-dir)
		    (if (first bend_dir)
			(if (vec-collinear-p (first new-dir) (first bend_dir))
			    (values :error "Direction collinear to specified Bend direction not allowed.")
			  :ok)
		      :ok))
		:after-input (progn
			       (handle-ok-next-action)
			       (sd-call-cmds (position_wp PIPE-wp
							  :pt_dir
							  :origin origin
							  :normal (first direction)
							  :done))
			       (start-dir-fback)))
    (u_achse_aendern
      :expand-shrink (UDIR)
      :expand-shrink-toggle-type :boolean
      :toggle-type :wide-toggle
      :title (sd-multi-lang-string "U Axis Direction" :german "U-Achsrichtung ndern")
      :initial-value nil
      :next-variable 'udir
    )
    (udir
      :value-type :measure-direction
      :built-in-feedback nil
      :initial-value nil
      :title (sd-multi-lang-string "U Direction" :german "U-Richtung")
      :before-input
      (setf udir nil)
      :after-input
      (progn
        (handle-ok-next-action)
        (sd-call-cmds
          (position_wp
            PIPE-wp
					  :pt_dir
					  :origin origin
					  :normal (first direction)
					  :u_dir (first udir)
					  :done
				  )
 			  )
 			  (setf u_achse_aendern nil)
 	    )
 	  )
	(Hilfslinie 	:expand-shrink (v_koord U_koord )
					:expand-shrink-toggle-type :boolean)
	(v_koord 		:value-type :length
					:title "V-Koordinate"
				    :after-input (progn
								(when (and v_koord u_koord)
									(sd-call-cmds (C_LINE_INF :HORIZONTAL v_koord));; horizontale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :VERTICAL u_koord));; vertikale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :HORIZONTAL 0));; horizontale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :VERTICAL 0));; vertikale Hilfegeometrie im Schwerpunkt erstellen
								)))
	(u_koord 		:value-type :length
					:title "U-Koordinate"
				    :after-input (progn
								(when (and v_koord u_koord)
									(sd-call-cmds (C_LINE_INF :HORIZONTAL v_koord));; horizontale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :VERTICAL u_koord));; vertikale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :HORIZONTAL 0));; horizontale Hilfegeometrie im Schwerpunkt erstellen
									(sd-call-cmds (C_LINE_INF :VERTICAL 0));; vertikale Hilfegeometrie im Schwerpunkt erstellen
								)))
    (subtitle-ruler-sec :title (sd-multi-lang-string "Cross Section" :german "Querschnitt"))
    (INKR	 
	     :value-type :boolean
	     :toggle-type :wide-toggle
	     :initial-value t
	     :title (sd-multi-lang-string "wrench size" :german "SW   Schlsselweite"))
    (UMKR	 
	     :value-type :boolean
	     :toggle-type :wide-toggle
	     :title (sd-multi-lang-string "external diameter" :german "UM Umkreisdurchmesser"))
	(ECKZAHL 
         :value-type :positive-integer
         :title (sd-multi-lang-string "number of pages" :german "Seitenzahl")
         :direction :input
         :prompt-text "Seitenzahl eingeben."
         :initial-value 6
	     :after-input (progn
			    (handle-ok-next-action)
			    (when PIPE-profile
			      (sd-call-cmds (delete_2d :all_2d)))
				  (GEOMETRY_MODE :REAL)					;ndert die Geometrieart auf "Geometrie" falls das nicht eingestellt ist
			      (progn
			           (sd-call-cmds
							(progn
							 (let (RAD_ID ALFAP ALFAS  ALFAC Counter X0 X1 XP Y0 Y1 YP)
							   (setq RAD_ID (/ SW_UM 2))
							   (c_circle :radius RAD_ID 0,0)
							   (setq ALFAP (/ (- 180 (/ 360 ECKZAHL)) 2))
							   (setq ALFAS (/ 360 ECKZAHL))
							   (if INKR
								   (setq RAD_ID (/ RAD_ID (sin (sd-deg-to-rad ALFAP)))) 
							   );;if
							   (dotimes (Counter ECKZAHL)
								 (setq ALFAC  (* ALFAS counter))
								 (setq X1 (* RAD_ID (cos (sd-deg-to-rad ALFAC) )))
								 (setq Y1 (* RAD_ID (sin (sd-deg-to-rad ALFAC) )))
								 (setq X1 (+ X1 (gpnt2d_x 0,0)))
								 (setq Y1 (+ Y1 (gpnt2d_y 0,0)))
								 (cond
								   ((> Counter 0)
									(line :two_points (make-gpnt2d :x X0 :y Y0) (make-gpnt2d :x X1 :y Y1))
								   ) 
								   ((= Counter 0)
									(setq XP X1)
									(setq YP Y1)
								   )
								 );;cond
								 (setq X0 X1)
								 (setq Y0 Y1)
							   );;dotimes
							   (line :two_points (make-gpnt2d :x X0 :y Y0) (make-gpnt2d :x XP :y YP))
							 );;let
							);;progn
						   );;sd-call-cmds
			      )
			    (sd-call-cmds (c_point 0,0))
			    (when (and bend_radius
				       (< bend_radius radius))
			      ;; invalid bend_radius for this radius => reset
			      (setq bend_radius nil))
			    (setq PIPE-profile t)))
    (SW_UM :value-type :positive-length
	     :title (sd-multi-lang-string "INKR UMKR" :german "Schlsselweite")
		 :auto-add-proposal T  ;; keep entered values
	     :after-input (progn
			    (handle-ok-next-action)
			    (when PIPE-profile
			      (sd-call-cmds (delete_2d :all_2d)))
				  (GEOMETRY_MODE :REAL)					;ndert die Geometrieart auf "Geometrie" falls das nicht eingestellt ist
			      (progn
			           (sd-call-cmds
							(progn
							 (let (RAD_ID ALFAP ALFAS  ALFAC Counter X0 X1 XP Y0 Y1 YP)
							   (setq RAD_ID (/ SW_UM 2))
							   (c_circle :radius RAD_ID 0,0)
							   (setq ALFAP (/ (- 180 (/ 360 ECKZAHL)) 2))
							   (setq ALFAS (/ 360 ECKZAHL))
							   (if INKR
								   (setq RAD_ID (/ RAD_ID (sin (sd-deg-to-rad ALFAP)))) 
							   );;if
							   (dotimes (Counter ECKZAHL)
								 (setq ALFAC  (* ALFAS counter))
								 (setq X1 (* RAD_ID (cos (sd-deg-to-rad ALFAC) )))
								 (setq Y1 (* RAD_ID (sin (sd-deg-to-rad ALFAC) )))
								 (setq X1 (+ X1 (gpnt2d_x 0,0)))
								 (setq Y1 (+ Y1 (gpnt2d_y 0,0)))
								 (cond
								   ((> Counter 0)
									(line :two_points (make-gpnt2d :x X0 :y Y0) (make-gpnt2d :x X1 :y Y1))
								   ) 
								   ((= Counter 0)
									(setq XP X1)
									(setq YP Y1)
								   )
								 );;cond
								 (setq X0 X1)
								 (setq Y0 Y1)
							   );;dotimes
							   (line :two_points (make-gpnt2d :x X0 :y Y0) (make-gpnt2d :x XP :y YP))
							 );;let
							);;progn
						   );;sd-call-cmds
			      )
			    (sd-call-cmds (c_point 0,0))
			    (when (and bend_radius
				       (< bend_radius radius))
			      ;; invalid bend_radius for this radius => reset
			      (setq bend_radius nil))
			    (setq PIPE-profile t)))
				
  	 (subtitle-ruler-straight :title (sd-multi-lang-string "Straight" :german "Gerade")) 
     (STRAIGHT_LENGTH :value-type :positive-length
		      :title (sd-multi-lang-string "Length" :german "Lnge")
              :proposals '() :auto-add-proposal T  ;; keep entered values
		      :after-input (switch-to-straight))
     (STRAIGHT_TO_PNT :value-type :point-3d
		      :title (sd-multi-lang-string "To Point" :german "Zu Punkt")
		      :after-input (switch-to-straight))

     (subtitle-ruler-bend :title (sd-multi-lang-string "Bend" :german "Biegung"))
     (BEND_RADIUS :value-type :positive-length
		  :title "Radius"
          :proposals '() :auto-add-proposal T  ;; keep entered values
		  :toggle-type :toggle-data

		  :check-function #'(lambda (new-radius)
				      (if (or (not radius)
					      (>= new-radius radius))
					  :ok
					(values :error "Bend radius less than PIPE radius not allowed.")))
		  :after-input (switch-to-bend))
     (BEND_ANGLE :value-type :angle
		 :title (sd-multi-lang-string "Angle" :german "Winkel")
         :proposals '() :auto-add-proposal T  ;; keep entered values
		 :initial-optional t
		 :after-input (switch-to-bend))
     (BEND_DIR :value-type :measure-direction
	       :built-in-feedback nil
	       :title (sd-multi-lang-string "Direction" :german "Richtung")
	       :initial-optional t
	       :check-function
	       #'(lambda (new-dir)
		   (if (first direction)
		       (if (vec-collinear-p (first new-dir) (first direction))
			   (values :error "Bend direction collinear to Direction not allowed.")
			 :ok)
		     :ok))
	       :after-input (switch-to-bend))
		   

		  
	(subtitle-ruler-segment :title (sd-multi-lang-string "Segment" :german "Segment"))
    (NEXT :toggle-type :grouped-toggle
	   :title (sd-multi-lang-string "Next" :german "Weiter")
	   :push-action (next-action))
    (BACK :toggle-type :grouped-toggle
	   :title (sd-multi-lang-string "Back" :german "Zurck")
	   :initial-enable nil
	   :push-action (back-action))
     )
   :mutual-exclusion '((straight_length straight_to_pnt bend_radius) (INKR UMKR))
   :local-functions
   ;;--------------
   '((cleanup ()
       (sd-end-feedback preview-fback)
       (sd-end-feedback dir-fback)
       (sd-call-cmds (delete_3d PIPE-wp))
       (sd-call-cmds (current_wp curr-wp)))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (handle-ok-next-action ()
       (setq next-performed nil)
       (sd-enable-must-variable-check))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (vec-collinear-p (vec1 vec2)
       (let ((angle (sd-vec-angle-between vec1 vec2)))
	 (if (or (< (abs angle) (sd-inq-default-geo-resolution))
		 (< (abs (- angle PI)) (sd-inq-default-geo-resolution)))
	     t
	   nil)))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (start-dir-fback ()
       (when (and origin (first direction))
	 (sd-end-feedback dir-fback)
	 (setq dir-fback (sd-start-direction-feedback
			  :point origin
			  :direction (first direction)
			  :disc nil))))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (end-dir-fback ()
       (sd-end-feedback dir-fback))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (start-preview-fback ()
       (end-preview-fback)
       (if straight
	   (progn
	     (if straight_length
		 (setq straight-len straight_length)
	       (setq straight-len
		     (sd-call-cmds (measure_dist :between_points
						 origin
						 straight_to_pnt
						 :direction (first direction)))))
	     (setq preview-fback (sd-start-direction-feedback
				  :point (sd-vec-translate origin
							   (first direction)
							   straight-len)
				  :direction (first direction))))
	 ;; ELSE: bend preview
	 (if (and bend_radius bend_angle bend_dir)
	     (let* ((cross1 (sd-vec-cross-product (first direction)
						  (first bend_dir)))
		    (cross2 (sd-vec-cross-product cross1 (first direction)))
		    (point (sd-vec-translate origin cross2 bend_radius)))
	       (setq preview-fback (sd-start-direction-feedback
				    :point (sd-vec-rotate origin
							  bend_angle
							  :point point
							  :direction cross1)
				    :direction (sd-dir-rotate
						(first direction)
						bend_angle
						:point point
						:direction cross1)))
	       (setq bend-axis (list point cross1)))
	   (setq bend-axis nil))))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (end-preview-fback ()
       (sd-end-feedback preview-fback))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (switch-to-straight ()
       (handle-ok-next-action)
       (setq straight t)
       (sd-set-variable-status 'bend_angle :optional t)
       (sd-set-variable-status 'bend_dir :optional t)
       (setq bend_angle nil)
       (setq bend_dir nil)
       (start-preview-fback))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (switch-to-bend ()
       (handle-ok-next-action)
       (setq straight nil)
       (sd-set-variable-status 'bend_radius :optional nil)
       (sd-set-variable-status 'bend_angle :optional nil)
       (sd-set-variable-status 'bend_dir :optional nil)
       (start-preview-fback))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    (next-action ()
       (setq next-performed t)
       (sd-disable-must-variable-check)
    (when (and PIPE_PART origin direction radius)
	(if straight
	     (when straight-len   ;; calculated in start-preview-fback
	       (end-dir-fback)
	       (end-preview-fback)
	       ;; remember current model state:
	       (push (list (sd-set-model-checkpoint) origin direction)
		     back-states)
	       ;; perform extrude and position_wp:
	    (sd-call-cmds (extrude 
					:part PIPE_PART	
					:wp PIPE-wp
				    :distance straight-len 
					:keep_wp :yes))
	    (sd-call-cmds 	(position_wp PIPE-wp :translate :dir_len
							(first direction) straight-len))
	(progn
        (sd-call-cmds (set_part_base_density :parts PIPE_PART :dens 0.00785))
		(sd-call-cmds (set_part_base_color :parts PIPE_PART :color :rgb 0.64,0.7,0.96))
    )
	    (setq origin (sd-inq-wp-origin PIPE-wp))
	    (start-dir-fback))
	   ;; ELSE: perform bend operation:
	(when bend-axis    ;; calculated in start-preview-fback
	     (end-dir-fback)
	     (end-preview-fback)
	     ;; remember current model state:
	     (push (list (sd-set-model-checkpoint) origin direction)
		   back-states)
	     ;; perform turn and position_wp:
	    (sd-call-cmds (turn 	
					:part PIPE_PART 
					:wp PIPE-wp
					:axis (first bend-axis) (second bend-axis)
					:rotation_angle bend_angle
					:keep_wp :yes))
	    (sd-call-cmds (position_wp PIPE-wp 
					:rotate
					:axis (first bend-axis) (second bend-axis)
					:rotation_angle bend_angle
					:done))
       (progn
	        (sd-call-cmds (set_part_base_density :parts PIPE_PART :dens 0.00785))
	        (sd-call-cmds (set_part_base_color :parts PIPE_PART :color :rgb 0.64,0.7,0.96))
       )
	     (setq bend_dir nil)
	     (setq origin (sd-inq-wp-origin PIPE-wp))
	     (setq direction (list (sd-inq-wp-w-dir PIPE-wp)))
	     (start-dir-fback))))
       (when back-states
	 (sd-set-variable-status 'back :enable t)))
     ;; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     (back-action ()
       (when back-states
	 (let ((state (pop back-states)))
	   (end-dir-fback)
	   (sd-return-to-model-checkpoint (first state))
	   (setq origin (second state))
	   (setq direction (third state))
	   (start-dir-fback))
	 (unless back-states
	   (sd-set-variable-status 'back :enable nil))))
     )  ;; end of local functions
   :ok-action '(progn
		 (unless next-performed
		   (next-action))
		 (cleanup))
   :cancel-action '(cleanup)
   )